#include "particle.hpp"
void ParticleSystem::generateParticlesFire()
{
	for(int i = 0; i < particles_c; i++)
    {
	   Particle z(rand()%30,rand()%30,pi*1.5,rand()%30);
	   particles.push_back(z);
    }
}
void ParticleSystem::draw()
{
	
	update_and_draw_particles();
	if(visible)_boxprint();
	wrefresh(win);
}
void ParticleSystem::update_and_draw_particles()
{
	//uaktualnij pozycje - ruszaj partyklami ;p
    update_particles(getWidth(),getHeight(),MAXAGE);
    //rysuj partykle 
    for(auto it = particles.begin();it!=particles.end();++it)
    {
       float percent_dead = float(it->life_left) / float(it->max_life);
       int dither = percent_dead * 6.0;
       int color = dither + 1;
       wattron(win,COLOR_PAIR(color));
       mvwaddch(win,it->y,it->x,dither_pattern[dither]);
       wattroff(win,COLOR_PAIR(color));
	}
}
void ParticleSystem::update_particles(int max_x, int max_y, float max_age)
{
  for(auto it = particles.begin(); it!= particles.end(); ++it)
  {      
    if(it->x <0 || it->y <0 || it->x > max_x || it->y > max_y)
    {
      it->x = rand()%max_x;
      it->y = max_y;
      it->direction = pi * 1.5;
      it->max_life= rand()%30 + 1;
      it->life_left = it->max_life;
    }
    else
	  it->move();
    if(it->life_left > 0)
    {
      it->life_left -= 1;
    }
    else
    {
      it->x = rand()%max_x;
      it->y = max_y;
      it->direction = pi * 1.5;
      it->max_life= rand()%30+1;
      it->life_left = it->max_life;
    }
  }
}
