#ifndef	particle_hpp
#define particle_hpp
#define DEFAULT_PARTICLES 200
#define MAXAGE		  	  3000
#define pi				  3.141
class Particle
{
   public:
      float x, y, max_life, life_left;
      float direction;    
      Particle()
      {
        x = 0;
        y = 0;
        max_life = 0;
        direction = 0;
        life_left = 0;
      }
      Particle(float x, float y, float direction, int max_life)
      {
        x = x;
        y = y;
        max_life = max_life;
        direction = direction;
        life_left = max_life;
      }
      void move()
      {
        x+=cos(direction);
        y+=sin(direction);
      }
};
class ParticleSystem : public Window
{
private:
	std::vector<Particle> particles;		// Particle
	int		  			  particles_c;		// Ilość cząsteczek
	int		  			  maxage;			// Wiek
	std::string dither_pattern = " # # # "; // domyślny wzór "Gaśnięcia"
public:
	ParticleSystem(short int _x,short int _y,short int _x1,short int _y1)
	: Window(_x,_y,_x1,_y1)
	{
		particles_c=DEFAULT_PARTICLES;	
	}
	ParticleSystem(short int _x,short int _y, short int _x1, short int _y1, int particles)
	: Window(_x,_y,_x1,_y1)
	{
		particles_c = particles;
	}
	void generateParticlesFire();
	void update_particles(int,int,float);
	void update_and_draw_particles();
	int getParticlesCount() {return particles_c;}
	void setMaxAge(float _age){maxage=_age;}
	void draw();
	void setPatternFire(char _p){dither_pattern[5] = _p;}
	void setPatternSmoke(char _p){dither_pattern[3] = _p;}
	void setPatternBlank(char _p){dither_pattern[1] = _p;}
	~ParticleSystem(){delwin(win);}
}; 
#endif 
