#ifndef window_hpp
#define window_hpp
class Window 
{
protected:
	WINDOW *win;
	short int x,x1;									// x,szer
	short int y,y1;									// y,wys
	short int max_x, max_y;							// Maksymalna rozdzielczość terminalu
	short int init_x,init_y;						
	bool	  visible;								// Czy obramowanie ma być widoczne
public:
	Window();
	Window(const short int _x,const short int _y,const short int _x1,const short int _y1);
	Window(const Window& w)							// Konstruktor kopiujący
	{
		x   = w.x;
		y   = w.y;	
		x1  = w.x1;
		y1  = w.y1;
		visible = true;
		win = newwin(x,y,x1,y1);
	}
	//////////////////////////SETTERY///////////////////////////////////
	inline void setWidth(const short int _y);				// Ustaw width					
	inline void setHeight(const short int _x);			// Ustaw height
	inline void setX(const short int _X);					// Ustaw X
	inline void setY(const short int _Y);					// Ustaw Y
	inline void	setmax()							// Maksymalna rozdzielczość terminalu
		{getmaxyx(stdscr, max_x, max_y);}			
	inline void setVisible(const bool _v) {visible = _v;}	// Ustaw widoczność obramowania
	//////////////////////////GETTERY///////////////////////////////////
	bool getVisible()		const {return visible;}	// Stan zmiennej visible
	short int getmX() 	 	const {return max_x;}	// Maksymalna wielkość X terminala
	short int getmY() 	 	const {return max_y;}	// Maksymalna wielkość Y terminala
	short int getHeight()  	const {return x;}		// wysokosc
	short int getWidth() 	const {return y;}		// szerokosc
	short int getX()		const {return x1;}		// Pozycja X
	short int getY()		const {return y1;}		// Pozycja Y
	//////////////////////////INNE//////////////////////////////////////
	void enableColor(const short int c)
	{wattron(this->win, COLOR_PAIR(c));}			// Ustaw atrybut koloru
	void disableColor(const short int c)
	{wattroff(this->win, COLOR_PAIR(c));}			// Wylącz kolor									
	////////////////////////////////////////////////////////////////////
	WINDOW* _ptr()	{return win;}					// Zwraca wskaźnik na okno
	void	_boxprint();							// Rysuj obramowanie
	virtual void draw();							// Rysuj, w ParticleSystem predefiniowana
	inline void nwin();								// Realokacja okna, gdy zmieniony parametr
	virtual ~Window(){delwin(win);}					// Wirtualny destruktor, ponieważ jest to klasa bazowa
};
#endif
